package com.fp.persistence.pgeneral.product;

import java.io.Serializable;
import java.lang.reflect.Field;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.HibernateBean;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TGENEPRODUCT
 */
@Entity(name = "TgeneProduct")
@Table(name = "TGENEPRODUCT")
public class TgeneProduct extends com.fp.dto.AbstractDataTransport implements
		Serializable, HibernateBean, Cloneable {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneProduct
	 */
	@EmbeddedId
	private TgeneProductKey pk;
	@Version
	@Column(name = "RECORDVERSION", nullable = true)
	/**
	 * Optimistic locking del registro
	 */
	private Integer recordversion;

	@Column(name = "DESCRIPTION", nullable = false)
	/**
	 * Nombre del producto
	 */
	private String description;

	/** Contructor por defecto */
	public TgeneProduct() {
	}

	/**
	 * Contructor de TgeneProduct
	 * 
	 * @param pPk
	 *            Clave Primaria del entity
	 * @param pDescription
	 *            Nombre del producto
	 */
	public TgeneProduct(TgeneProductKey pPk, String pDescription) {
		this();
		pk = pPk;
		description = pDescription;
	}

	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager
	 *            referencia de la session a obtener datos del bean.
	 * @param pKey
	 *            Caleve primaria del bean.
	 * @return TgeneProduct
	 */
	public static TgeneProduct find(EntityManager pEntityManager,
			TgeneProductKey pKey) throws Exception {
		TgeneProduct obj = pEntityManager.find(TgeneProduct.class, pKey);
		return obj;
	}

	/**
	 * Entrega la Clave primaria de TgeneProduct
	 * 
	 * @return El objeto que referencia a la Clave primaria de TgeneProduct
	 */
	public TgeneProductKey getPk() {
		return pk;
	}

	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneProduct
	 * 
	 * @param pPk
	 *            El objeto que referencia a la nueva Clave primaria de
	 *            TgeneProduct
	 */
	public void setPk(TgeneProductKey pPk) {
		pk = pPk;
	}

	/**
	 * Obtiene el valor de recordversion
	 * 
	 * @return valor de recordversion
	 */
	public Integer getRecordversion() {
		return recordversion;
	}

	/**
	 * Fija el valor de recordversion
	 * 
	 * @param pRecordversion
	 *            nuevo Valor de recordversion
	 */
	public void setRecordversion(Integer pRecordversion) {
		recordversion = pRecordversion;
	}

	/**
	 * Obtiene el valor de description
	 * 
	 * @return valor de description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Fija el valor de description
	 * 
	 * @param pDescription
	 *            nuevo Valor de description
	 */
	public void setDescription(String pDescription) {
		description = pDescription;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneProduct))
			return false;
		TgeneProduct that = (TgeneProduct) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}

	/**
	 * Implementación del metodo hashCode de la la entidad TgeneProduct
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}

	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0
						|| name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}

	/** Implementación de la creación de un bean en blanco TgeneProduct */
	public Object createInstance() {
		TgeneProduct instance = new TgeneProduct();
		instance.setPk(new TgeneProductKey());
		return instance;
	}

	/**
	 * Clona la entidad TgeneProduct
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneProduct p = (TgeneProduct) this.clone();
		p.setPk((TgeneProductKey) this.pk.cloneMe());
		return p;
	}
	
	//Metodos manuales.
    /**
     * Sentencia que devuelve un registro de TgeneProduct.
     */
    private static final String JPQL_TGENE_PRODUCT =
            "from TgeneProduct tprod  "
            + " where tprod.pk.modulecode = :modulecode "
            + " and tprod.pk.productcode = :productcode ";

    /**
     * Metodo que obtiene datos de un registro del producto.
     * @param pModulecode  Codigo de modulo a obtener datos de la base.
     * @param pProductcode  Codigo de producto a obtener datos de la base.
     * @return  TgeneProduct
     * @throws Exception
     */
    public static TgeneProduct find(EntityManager pEntityManager,String pModulecode, String pProductcode) throws Exception {
    	Query qry = pEntityManager.createQuery(JPQL_TGENE_PRODUCT);        
    	qry.setParameter("modulecode", pModulecode);
    	qry.setParameter("productcode", pProductcode);
    	try {
    		return (TgeneProduct) qry.getSingleResult();	
		} catch (NoResultException e) {
			return null;
		}        
    }
	
	
}
